<?php
/*
Plugin Name: WP-Video
Plugin URI: http://www.nabito.net/
Description: Adds Google, YouTUBE, Metacafe videos to a wordpress entry very simple.
Version: 2.1
Author: Roman Ožana
Author URI: http://www.nabito.net

Example:

	1. Search your favorites video in
	
		http://video.google.com/
		http://www.youtube.com/
		http://www.metacafe.com/
		
	2. Copy with Ctrl+C shortcut URL
	   for example http://video.google.com/videoplay?docid=-7252358302693329551
	
	3. Create new paragraph in your entry, insert string from clipboard by shortcut Ctrl+V
	
	4. Rewrite protocol name from http to video
	 like this video://video.google.com/videoplay?docid=-7252358302693329551
	 
	 Example HTML
	 
	 <p>Great czech actor Josef Polášek in Orbit promo clip</p>
	 <p>video://video.google.com/videoplay?docid=-7252358302693329551</p>
	 
Note:

	This plugin generate XHTML strict code, specially for MSIE and other web explorers
	
	If You have any problem with plugin, please write on email admin@nabito.net.

*/
function video($text)
{
	// GOOGLE VIDEO
	// video://video.google.com/videoplay?docid=-2015113260462695028 // href
	// http://video.google.com/googleplayer.swf?docId=1047157044159649860 //player
	
	// YOUTUBE
	// video://www.youtube.com/watch?v=4Lj1_WwyzK8&mode=related&search= // href
	// http://www.youtube.com/v/hABzxZSVnL0 // player
	
	// MATACAFE
	// video://www.metacafe.com/watch/129909/family_guy_osama_bin_laden/ //href
	// http://www.metacafe.com/fplayer/129909/family_guy_osama_bin_laden.swf // player
	
	//Added by ExtremeAmbient.net
	//MYSPACE
	//video://vids.myspace.com/index.cfm?fuseaction=vids.individual&videoID=683035500 //href
	//http://lads.myspace.com/videos/vplayer.swf?m=683035500&type=video	//player
	
	// regular
	$preg['google']  = '/<p>?[\s.]*video:\/\/video.google.com\/videoplay\?docid=([^<\s]+)[&\s.]*<\/p>?/'; // GOOGLE
	$preg['youtub']  = '/<p>?[\s.]*video:\/\/www.youtube.com\/watch\?v=([^<\s]+)[\s.]*<\/p>?/'; // YOUTUBE
	$preg['metaca']  = '/<p>?[\s.]*video:\/\/www.metacafe.com\/watch\/([^<\s]+)\/[\s.]*<\/p>?/'; // METACAFE
	$preg['myspace']  = '/<p>?[\s.]*video:\/\/vids.myspace.com\/index.cfm\?fuseaction=vids.individual(&|&amp;|&#038;)videoID=([^<\s]+)[\s.]*<\/p>?/'; // MYSPACE
	
	// add style
	$match['google']  = '<div class="video google" align="center">'; // GOOGLE
	$match['youtub']  = '<div class="video youtube" align="center">'; // YOUTUBE
	$match['metaca']  = '<div class="video metacafe" align="center">'; // METACAFE
	$match['myspace']  = '<div class="video myspace" align="center">'; // MYSPACE
	
	if (stristr($_SERVER['HTTP_USER_AGENT'], 'MSIE'))
	{
		// MSIE settings by classid
		$to_all = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0" width="400" height="325">';
		$match['google'] .= $to_all; // GOOGLE
		$match['youtub'] .= $to_all; // YOUTUBE
		$match['metaca'] .= $to_all; // METACAFE
		$match['myspace'] .= $to_all; // MYSPACE
	} else 
	{
		// other NO MSIE explorers
		$match['google'] .= '<object type="application/x-shockwave-flash" data="http://video.google.com/googleplayer.swf?docId=\\1" width="400" height="325">'; // GOOGLE
		$match['youtub'] .= '<object type="application/x-shockwave-flash" data="http://www.youtube.com/v/\\1" width="400" height="325">'; // YOUTUBE
		$match['metaca'] .= '<object type="application/x-shockwave-flash" data="http://www.metacafe.com/fplayer/\\1.swf" width="400" height="325">'; // METACAFE
		$match['myspace'] .= '<object type="application/x-shockwave-flash" data="http://lads.myspace.com/videos/vplayer.swf?m=\\2&amp;type=video" width="400" height="325">'; // MYSPACE
	}
	// add parameter movie
	$match['google'] .= '<param name="movie" value="http://video.google.com/googleplayer.swf?docId=\\1&amp;hl=en" />'; // GOOGLE
	$match['youtub'] .= '<param name="movie" value="http://www.youtube.com/v/\\1" />'; //YOUTUBE
	$match['metaca'] .= '<param name="movie" value="http://www.metacafe.com/fplayer/\\1.swf" />'; //METACAFE
	$match['myspace'] .= '<param name="movie" value="http://lads.myspace.com/videos/vplayer.swf" />'; //MYSPACE
	$match['myspace'] .= '<param name="flashvars" value="m=\\2&amp;type=video" />';
	
	// to all flash player
	$to_all  = '<param name="allowScriptAccess" value="sameDomain" />'; // new TO ALL
	$to_all .= '<param name="menu" value="false" />';
	$to_all .= '<param name="quality" value="best" />';
	$to_all .= '<param name="bgcolor" value="#ffffff" />';
	$to_all .= '<param name="scale" value="doesaffect" />';
	$to_all .= '<p>Su navegador no es capaz de reproducir Flash <a href="http://download.macromedia.com/" title="Download Falsh">Descargalo aquí</a>.</p>';
	$to_all .= '</object></div>';
	
	$match['google'] .= $to_all; // GOOGLE
	$match['youtub'] .= $to_all; // YOUTUBE
	$match['metaca'] .= $to_all; // METACAFE
	$match['myspace'] .= $to_all; // MYSPACE
	
	return preg_replace($preg, $match, $text); // preg replace in text
}

add_filter('the_content','video',10); // add filter to WP
?>
